/**************************************************************************

	main.c

	tdLaunch
	(C) Copyright 2001 By Tomoaki Nakashima. All right reserved.
		http://www.nakka.com/
		nakka@nakka.com

	tbLaunch4SE
	(C) Copyright 2005 UK-taniyama. All right reserved.
		http://homepage3.nifty.com/UK-taniyama/tools/tdLaunch4SE.html

	tbLaunch4SE_es
	(C) Copyright 2006 By YOD-Y. All right reserved.
		http://www25.big.or.jp/~hidea/
		jca03271@nifty.com

	Reference materials.
	cLaunch, http://pachome1.pacific.net.sg/~welic/claunch.html

**************************************************************************/

/**************************************************************************
	Include Files
**************************************************************************/

#define _WCE_PPC2002

#define _INC_OLE
#include <windows.h>
#undef  _INC_OLE
#include <Todaycmn.h>
#include <Commctrl.h>
#include <commdlg.h>
#include <aygshell.h>
#include <imm.h>
#include "SelectFile.h"
#include "resource.h"

#pragma comment ( lib, "aygshell.lib")


/**************************************************************************
	Define
**************************************************************************/

#define WINDOW_TITLE			_T("tdLaunch")
#define MAIN_WND_CLASS			_T("tdLaunchWndClass")

#define REG_PATH				_T("Software\\tdLaunch")
#define REG_FILELIST			_T("Software\\tdLaunch\\FileList")

#define FILE_EXPLORER			_T("fexplore.exe")

#define ID_ICON_TIMER			1

#define NUMBMP_CNT				12
#define BUF_SIZE				256


/**************************************************************************
	Global Variables
**************************************************************************/

static HINSTANCE hInst;
static HWND hToolTip;

static TCHAR backbmpfile[BUF_SIZE];
static int stretch_backbmp = 0;
static int CtrlUpDown = 1;
static int IconSize = 16;
static int HMargin = 2;
static int VMargin = 2;
static int WinLeftMargin = 0;
static int WinTopMargin = 0;
static int WinRightMargin = 13;
static int WinBottomMargin = 5;
static int ShowIconSec = 1;
static BOOL hasFocus = FALSE;

static BOOL Refresh;

typedef struct _FILELIST {
	TCHAR Name[BUF_SIZE];
	TCHAR FileName[BUF_SIZE];
	TCHAR CommnadLine[BUF_SIZE];
	int Index;
} FILELIST;

static FILELIST *FileList;
static HIMAGELIST IconList;
static int FileListCnt;
static int SelItem = -1;
static int CurItem = 0;


#if 0
BOOL OutputFile (TCHAR* out)
{
	HANDLE hFile;
	DWORD dwWrited;

	hFile = CreateFile (_T("\\My Documents\\log.txt"), GENERIC_WRITE, 0, NULL, OPEN_ALWAYS, FILE_ATTRIBUTE_NORMAL, NULL);
	if (hFile == INVALID_HANDLE_VALUE) return FALSE;

	SetFilePointer (hFile, 0, NULL, FILE_END);

	dwWrited = 0;
	WriteFile (hFile, out, sizeof(TCHAR)*_tcslen (out), &dwWrited, NULL);
	WriteFile (hFile, _T("\r\n"), sizeof(TCHAR)*2, &dwWrited, NULL);

	CloseHandle (hFile);
	return TRUE;
}
#endif//0

/******************************************************************************

	DllMain

	DllMain

******************************************************************************/

BOOL WINAPI DllMain(HINSTANCE hModule, DWORD fdwReason, PVOID pvReserved)
{
	hInst = hModule;
	return TRUE;
}


/******************************************************************************

	GetOption

	ݒ̓ǂݍ

******************************************************************************/

static void GetOption(void)
{
	HKEY hKey;
	DWORD rc;
	DWORD dwType;
	long len;
	long ret;

	if(RegCreateKeyEx(HKEY_CURRENT_USER, REG_PATH, 0, _T(""), REG_OPTION_NON_VOLATILE, KEY_ALL_ACCESS, NULL, &hKey, &rc) == ERROR_SUCCESS){
		len = sizeof(TCHAR) * BUF_SIZE;
		ret = RegQueryValueEx(hKey, _T("backbmpfile"), NULL, &dwType, (LPBYTE)&backbmpfile, &len);
		len = sizeof(int);
		ret = RegQueryValueEx(hKey, _T("stretch_backbmp"), NULL, &dwType, (LPBYTE)&stretch_backbmp, &len);
		len = sizeof(int);
		ret = RegQueryValueEx(hKey, _T("CtrlUpDown"), NULL, &dwType, (LPBYTE)&CtrlUpDown, &len);
		len = sizeof(int);
		ret = RegQueryValueEx(hKey, _T("IconSize"), NULL, &dwType, (LPBYTE)&IconSize, &len);
		len = sizeof(int);
		ret = RegQueryValueEx(hKey, _T("HMargin"), NULL, &dwType, (LPBYTE)&HMargin, &len);
		len = sizeof(int);
		ret = RegQueryValueEx(hKey, _T("VMargin"), NULL, &dwType, (LPBYTE)&VMargin, &len);
		len = sizeof(int);
		ret = RegQueryValueEx(hKey, _T("WinLeftMargin"), NULL, &dwType, (LPBYTE)&WinLeftMargin, &len);
		len = sizeof(int);
		ret = RegQueryValueEx(hKey, _T("WinTopMargin"), NULL, &dwType, (LPBYTE)&WinTopMargin, &len);
		len = sizeof(int);
		ret = RegQueryValueEx(hKey, _T("WinRightMargin"), NULL, &dwType, (LPBYTE)&WinRightMargin, &len);
		len = sizeof(int);
		ret = RegQueryValueEx(hKey, _T("WinBottomMargin"), NULL, &dwType, (LPBYTE)&WinBottomMargin, &len);
		len = sizeof(int);
		ret = RegQueryValueEx(hKey, _T("ShowIconSec"), NULL, &dwType, (LPBYTE)&ShowIconSec, &len);
		RegCloseKey(hKey);
	}
}


/******************************************************************************

	SetOption

	ݒ̕ۑ

******************************************************************************/

static void SetOption(void)
{
	HKEY hKey = 0;
	DWORD rc;

	//WXgɐݒۑ
	if(RegCreateKeyEx(HKEY_CURRENT_USER, REG_PATH, 0, _T(""), REG_OPTION_NON_VOLATILE, KEY_ALL_ACCESS, NULL, &hKey, &rc) == ERROR_SUCCESS){
		RegSetValueEx(hKey, _T("backbmpfile"), 0, REG_SZ, (LPBYTE)backbmpfile, sizeof(TCHAR) * (lstrlen(backbmpfile) + 1));
		RegSetValueEx(hKey, _T("stretch_backbmp"), 0, REG_DWORD, (LPBYTE)&stretch_backbmp, sizeof(int));
		RegSetValueEx(hKey, _T("CtrlUpDown"), 0, REG_DWORD, (LPBYTE)&CtrlUpDown, sizeof(int));
		RegSetValueEx(hKey, _T("IconSize"), 0, REG_DWORD, (LPBYTE)&IconSize, sizeof(int));
		RegSetValueEx(hKey, _T("HMargin"), 0, REG_DWORD, (LPBYTE)&HMargin, sizeof(int));
		RegSetValueEx(hKey, _T("VMargin"), 0, REG_DWORD, (LPBYTE)&VMargin, sizeof(int));
		RegSetValueEx(hKey, _T("WinLeftMargin"), 0, REG_DWORD, (LPBYTE)&WinLeftMargin, sizeof(int));
		RegSetValueEx(hKey, _T("WinTopMargin"), 0, REG_DWORD, (LPBYTE)&WinTopMargin, sizeof(int));
		RegSetValueEx(hKey, _T("WinRightMargin"), 0, REG_DWORD, (LPBYTE)&WinRightMargin, sizeof(int));
		RegSetValueEx(hKey, _T("WinBottomMargin"), 0, REG_DWORD, (LPBYTE)&WinBottomMargin, sizeof(int));
		RegSetValueEx(hKey, _T("ShowIconSec"), 0, REG_DWORD, (LPBYTE)&ShowIconSec, sizeof(int));
		RegCloseKey(hKey);
	}
}


/******************************************************************************

	sort_func

	\[g֐

******************************************************************************/

static int __cdecl sort_func(const void *arg1, const void *arg2)
{
	FILELIST *f1 = (FILELIST *)arg1;
	FILELIST *f2 = (FILELIST *)arg2;

	return f1->Index - f2->Index;
}


/******************************************************************************

	CreateFileList

	t@C̈ꗗ쐬

******************************************************************************/

void CreateFileList()
{
	HKEY hKey = 0;
	HKEY hFileKey = 0;
	TCHAR buf[BUF_SIZE];
	DWORD dwType;
	DWORD rc;
	long cnt = 0;
	long len;
	int i;

	if(FileList != NULL){
		LocalFree(FileList);
	}
	FileList = NULL;
	FileListCnt = 0;

	if(RegCreateKeyEx(HKEY_CURRENT_USER, REG_FILELIST, 0, _T(""), REG_OPTION_NON_VOLATILE, KEY_ALL_ACCESS, NULL, &hKey, &rc) != ERROR_SUCCESS){
		return;
	}
	//TuL[̐擾
	if(RegQueryInfoKey(hKey, NULL, NULL, NULL, &cnt, NULL, NULL, NULL, NULL, NULL, NULL, NULL) != ERROR_SUCCESS){
		return;
	}
	FileList = (FILELIST *)LocalAlloc(LPTR, sizeof(FILELIST) * cnt);
	if(FileList == NULL){
		return;
	}
	FileListCnt = cnt;

	for(i = 0; i < cnt; i++){
		len = sizeof(TCHAR) * BUF_SIZE;
		if(RegEnumKeyEx(hKey, i, (FileList + i)->Name, &len, NULL, NULL, NULL, NULL) == ERROR_SUCCESS){
			wsprintf(buf, _T("%s\\%s"), REG_FILELIST, (FileList + i)->Name);
			if(RegCreateKeyEx(HKEY_CURRENT_USER, buf, 0, _T(""), REG_OPTION_NON_VOLATILE, KEY_ALL_ACCESS, NULL, &hFileKey, &rc) == ERROR_SUCCESS){
				len = sizeof(TCHAR) * BUF_SIZE;
				RegQueryValueEx(hFileKey, _T("FileName"), NULL, &dwType, (LPBYTE)&((FileList + i)->FileName), &len);
				RegQueryValueEx(hFileKey, _T("CommnadLine"), NULL, &dwType, (LPBYTE)&((FileList + i)->CommnadLine), &len);
				len = sizeof(int);
				RegQueryValueEx(hFileKey, _T("Index"), NULL, &dwType, (LPBYTE)&((FileList + i)->Index), &len);
				RegCloseKey(hFileKey);
			}
		}
	}
	RegCloseKey(hKey);

	if(FileListCnt > 1){
		qsort(FileList, FileListCnt, sizeof(FILELIST), sort_func);
	}
}


/******************************************************************************

	RegDeleteFileList

	t@C̈ꗗ̍폜

******************************************************************************/

void RegDeleteFileList()
{
	HKEY hKey = 0;
	TCHAR buf[BUF_SIZE];
	TCHAR SubKey[BUF_SIZE];
	DWORD rc;
	long len;
	long cnt = 0;
	int i;

	//WXg̍폜
	if(RegCreateKeyEx(HKEY_CURRENT_USER, REG_FILELIST, 0, _T(""), REG_OPTION_NON_VOLATILE, KEY_ALL_ACCESS, NULL, &hKey, &rc) == ERROR_SUCCESS){
		//TuL[̐擾
		if(RegQueryInfoKey(hKey, NULL, NULL, NULL, &cnt, NULL, NULL, NULL, NULL, NULL, NULL, NULL) == ERROR_SUCCESS){
			for(i = cnt - 1; i >= cnt; i--){
				len = sizeof(TCHAR) * BUF_SIZE;
				if(RegEnumKeyEx(hKey, i, SubKey, &len, NULL, NULL, NULL, NULL) == ERROR_SUCCESS){
					wsprintf(buf, _T("%s\\%s"), REG_FILELIST, SubKey);
					RegDeleteKey(HKEY_CURRENT_USER, buf);
				}
			}
		}
		RegCloseKey(hKey);
	}
	RegDeleteKey(HKEY_CURRENT_USER, REG_FILELIST);
}


/******************************************************************************

	SaveFileList

	t@C̈ꗗۑ

******************************************************************************/

void SaveFileList()
{
	HKEY hKey = 0;
	TCHAR buf[BUF_SIZE];
	DWORD rc;
	int i;

	RegDeleteFileList();

	for(i = 0; i < FileListCnt; i++){
		wsprintf(buf, _T("%s\\%s"), REG_FILELIST, (FileList + i)->Name);
		if(RegCreateKeyEx(HKEY_CURRENT_USER, buf, 0, _T(""), REG_OPTION_NON_VOLATILE, KEY_ALL_ACCESS, NULL, &hKey, &rc) == ERROR_SUCCESS){
			RegSetValueEx(hKey, _T("FileName"), 0, REG_SZ, (LPBYTE)((FileList + i)->FileName), sizeof(TCHAR) * (lstrlen((FileList + i)->FileName) + 1));
			RegSetValueEx(hKey, _T("CommnadLine"), 0, REG_SZ, (LPBYTE)((FileList + i)->CommnadLine), sizeof(TCHAR) * (lstrlen((FileList + i)->CommnadLine) + 1));
			RegSetValueEx(hKey, _T("Index"), 0, REG_DWORD, (LPBYTE)&((FileList + i)->Index), sizeof(int));
			RegCloseKey(hKey);
		}
	}
}


/******************************************************************************

	ToolTipProc

	c[`bv

******************************************************************************/

static BOOL CALLBACK ToolTipProc(HWND hDlg, UINT uMsg, WPARAM wParam, LPARAM lParam)
{
	PAINTSTRUCT ps;
	RECT rect;
	SIZE sz;
	HDC hdc;
	static TCHAR buf[BUF_SIZE];

	switch (uMsg) {
	case WM_INITDIALOG:
		break;

	case WM_LBUTTONDOWN:
		ShowWindow(hDlg, SW_HIDE);
		break;

	case WM_SETTEXT:
		if(lParam == 0){
			break;
		}
		lstrcpy(buf, (TCHAR *)lParam);

		hdc = GetDC(hDlg);
		GetTextExtentPoint32(hdc, buf, lstrlen(buf), &sz);
		ReleaseDC(hDlg, hdc);

		SetWindowPos(hDlg, 0, 0, 0, sz.cx + 6, sz.cy + 6, SWP_NOMOVE | SWP_NOZORDER | SWP_HIDEWINDOW | SWP_NOACTIVATE);
		break;

	case WM_PAINT:
		hdc = BeginPaint(hDlg, &ps);

		GetClientRect(hDlg,(LPRECT)&rect);
		FillRect(hdc, &rect, (HBRUSH)GetStockObject(WHITE_BRUSH));
		ExtTextOut(hdc, 2, 2, ETO_OPAQUE, NULL, buf, lstrlen(buf), NULL);

		EndPaint(hDlg, &ps);
		break;

	default:
		return FALSE;
	}
	return TRUE;
}


/******************************************************************************

	ImageListIconAdd

	C[WXgɃACRǉ

******************************************************************************/

static void ImageListIconAdd(HIMAGELIST hIconList, HIMAGELIST SysIconList, int IconSize, TCHAR *path, TCHAR *File)
{
	WIN32_FIND_DATA FindData;
	HANDLE hFindFile;
	HICON hIcon = NULL;
	SHFILEINFO  shfi;
	TCHAR buf[BUF_SIZE];

	if(path != NULL){
		wsprintf(buf, _T("%s\\%s"), path, File);
	}else{
		lstrcpy(buf, File);
	}
	if(lstrcmp(buf, _T("\\")) == 0){
		lstrcpy(buf, _T("\\windows"));
	}

	if((hFindFile = FindFirstFile(buf, &FindData)) != INVALID_HANDLE_VALUE){
		FindClose(hFindFile);

		//֘AtꂽACR̎擾
		SHGetFileInfo(buf, 0, &shfi, sizeof(SHFILEINFO), SHGFI_SYSICONINDEX);
		hIcon = ImageList_GetIcon(SysIconList, shfi.iIcon, ILD_NORMAL);
	}
	if(hIcon == NULL){
		//AvP[VACR̎擾
		hIcon = LoadIcon(hInst, MAKEINTRESOURCE(IDI_ICON_NON));
	}

	//C[WXgɃACRǉ
	ImageList_AddIcon(hIconList, hIcon);
	DestroyIcon(hIcon);
}


/******************************************************************************

	SetImegeListIcon

	C[WXgݒ

******************************************************************************/

BOOL SetImegeListIcon(FILELIST *FileList, int IconCnt, int IconSize)
{
	HIMAGELIST SysIconList;
	SHFILEINFO  shfi;
	HICON hIcon = NULL;
	int size;
	int i;
	int lSize = GetSystemMetrics(SM_CXICON);
	int sSize = GetSystemMetrics(SM_CXSMICON);
	int mSize = (sSize+lSize)/2;

	//C[WXg̍쐬
	if(IconList != NULL){
		ImageList_Destroy ((void*)IconList);
		IconList = NULL;
	}

	//VXeC[WXg̎擾
	SysIconList = (HIMAGELIST)SHGetFileInfo(_T(""), 0, &shfi, sizeof(SHFILEINFO),
		SHGFI_ICON | ((IconSize < mSize) ? SHGFI_SMALLICON : 0) | SHGFI_SYSICONINDEX);
	if(SysIconList == NULL){
		return FALSE;
	}

	size = ((IconSize < mSize) ? sSize : lSize);
	IconList = ImageList_Create(size, size, ILC_COLOR | ILC_MASK, IconCnt, IconCnt);

	//t@CACR̒ǉ
	for (i = 0; i < IconCnt; i++){
		ImageListIconAdd (IconList, SysIconList, IconSize, NULL, (FileList + i)->FileName);
	}
	return TRUE;
}


/******************************************************************************

	_ImageList_DrawEx

	C[WXg̃ACR`

******************************************************************************/

BOOL _ImageList_DrawEx(HIMAGELIST himl, int i, HDC hdcDst, int x, int y, int dx, int dy, COLORREF rgbBk, COLORREF rgbFg, UINT fStyle)
{
#if 0
	int lSize = GetSystemMetrics(SM_CXICON);
	int sSize = GetSystemMetrics(SM_CXSMICON);

	if(himl == NULL){
		return FALSE;
	}
	if(dx == sSize || dx == lSize){
		return ImageList_Draw (himl, i, hdcDst, x, y, ILD_NORMAL);
	}
	ImageList_DrawEx (himl, i, hdcDst, x, y, dx, dy, CLR_NONE, CLR_NONE, fStyle);
	return TRUE;
#endif//0

	// from tbLaunch
	int lSize = GetSystemMetrics(SM_CXICON);
	int sSize = GetSystemMetrics(SM_CXSMICON);
	int mSize = (sSize+lSize)/2;

	HDC memdc;
	HBITMAP hBitMap;
	HBITMAP hRetMemBmp;
	HBRUSH hBrush;
	RECT rect;
	int size;

	if (himl == NULL) {
		return FALSE;
	}
	if (dx == lSize || dx == sSize) {
		return ImageList_Draw (himl, i, hdcDst, x, y, ILD_NORMAL);
	}

	size = ((IconSize < mSize) ? sSize : lSize);

	memdc = CreateCompatibleDC (hdcDst);
	hBitMap = CreateCompatibleBitmap (hdcDst, size, size);
	hRetMemBmp = SelectObject (memdc, hBitMap);

	hBrush = CreateSolidBrush (RGB(255, 0, 255));
	SetRect (&rect, 0, 0, size, size);
	FillRect (memdc, &rect, hBrush);
	DeleteObject (hBrush);

	ImageList_DrawEx (himl, i, memdc, 0, 0, size, size, RGB(255, 0, 255), CLR_NONE, fStyle);
	TransparentImage (hdcDst, x, y, dx, dy, memdc, 0, 0, size, size, RGB(255, 0, 255));

	SelectObject (memdc, hRetMemBmp);
	DeleteObject (hBitMap);
	DeleteDC (memdc);
	return TRUE;
}


/******************************************************************************

	OnPaint

	ACR̕`

******************************************************************************/

void OnPaint(HWND hWnd, HDC hdc, PAINTSTRUCT *ps, HBITMAP hBackBmp)
{
#ifdef _WCE_PPC2002
	TODAYDRAWWATERMARKINFO dwi;
#endif
	HDC drawdc;
	HDC mdc;
	HBITMAP hDrawBitMap;
	HBITMAP hRetDrawBmp;
	HBITMAP hRetBmp;
	RECT rect;
	RECT selrect;
	BITMAP bmp;
	int x, y;
	int i;
	HBRUSH hBrush;

	//EBhETCYɍ킹rbg}bvi[鉼zEBhE̍쐬
	GetClientRect(hWnd, (LPRECT)&rect);

	//`pzDC
	drawdc = CreateCompatibleDC(hdc);
	hDrawBitMap = CreateCompatibleBitmap(hdc, rect.right, rect.bottom);
	hRetDrawBmp = SelectObject(drawdc, hDrawBitMap);

#ifdef _WCE_PPC2002
	dwi.hdc = drawdc;
	GetClientRect(hWnd, &dwi.rc);
	dwi.hwnd = hWnd;
	SendMessage(GetParent(hWnd), TODAYM_DRAWWATERMARK, 0, (LPARAM)&dwi);
#else
	FillRect(drawdc, &rect, (HBRUSH)GetStockObject(WHITE_BRUSH));
#endif

	//wi̕`
	if(hBackBmp != NULL){
		mdc = CreateCompatibleDC(hdc);
		hRetBmp = SelectObject(mdc, hBackBmp);
		if (stretch_backbmp == 0){
			BitBlt(drawdc, 0, 0, rect.right, rect.bottom, mdc, 0, 0, SRCCOPY);
		}
		else{
			GetObject(hBackBmp, sizeof(BITMAP), &bmp);
			StretchBlt(drawdc, 0, 0, rect.right, rect.bottom, mdc, 0, 0, bmp.bmWidth, bmp.bmHeight, SRCCOPY);
		}
		SelectObject(mdc, hRetBmp);
		DeleteDC(mdc);
	}

	//ACR̕`
	x = WinLeftMargin;
	y = WinTopMargin;
	for (i = 0; i < FileListCnt; i++) {
		if((x + IconSize + (HMargin * 2)) > GetSystemMetrics(SM_CXSCREEN) - WinRightMargin){
			x = WinLeftMargin;
			y += IconSize + (VMargin * 2);
		}
		if (SelItem == i) {
			//IACR
			SetRect(&selrect, x, y, x + IconSize + (HMargin * 2), y + IconSize + (VMargin * 2));
			hBrush = CreateSolidBrush(GetSysColor(COLOR_HIGHLIGHT));
			FillRect(drawdc, &selrect, hBrush);
			DeleteObject(hBrush);
		}
		_ImageList_DrawEx (IconList, i,
			drawdc, x + HMargin, y + VMargin, IconSize, IconSize, CLR_NONE, 0,
			ILD_NORMAL);
		x += IconSize + (HMargin * 2);
	}

	BitBlt (hdc, ps->rcPaint.left, ps->rcPaint.top, ps->rcPaint.right, ps->rcPaint.bottom,
		drawdc, ps->rcPaint.left, ps->rcPaint.top, SRCCOPY);

	SelectObject(drawdc, hRetDrawBmp);
	DeleteObject(hDrawBitMap);
	DeleteDC(drawdc);
}


/******************************************************************************

	Point2Item

	ʒuACe擾

******************************************************************************/

static int Point2Item(int px, int py)
{
	RECT rect;
	POINT pt;
	int x, y;
	int i;

	pt.x = px;
	pt.y = py;
	for(x = WinLeftMargin, y = WinTopMargin, i = 0; i < FileListCnt; i++){
		if((x + IconSize + (HMargin * 2)) > GetSystemMetrics(SM_CXSCREEN) - WinRightMargin){
			x = WinLeftMargin;
			y += IconSize + (VMargin * 2);
		}
		SetRect(&rect, x, y, x + IconSize + (HMargin * 2), y + IconSize + (VMargin * 2));
		if(PtInRect(&rect, pt) == TRUE){
			return i;
		}
		x += IconSize + (HMargin * 2);
	}
	return -1;
}


/******************************************************************************

	ShowToolTip

	tooltipEBhE\

******************************************************************************/

static BOOL ShowToolTip( HWND hWnd, int px, int py)
{
	RECT rect;
	RECT tip_rect;

	SendMessage(hToolTip, WM_SETTEXT, 0, (LPARAM)(FileList + SelItem)->Name);
	GetWindowRect(hWnd, &rect);
	GetWindowRect(hToolTip, &tip_rect);
	tip_rect.left = rect.left + px - (tip_rect.right - tip_rect.left) - 2;
	if(tip_rect.left < 0) tip_rect.left = 0;
	tip_rect.top = rect.top + py - (tip_rect.bottom - tip_rect.top) - 2;
	if(tip_rect.top < 0) tip_rect.top = rect.bottom;

	SetWindowPos(hToolTip, HWND_TOPMOST,
		tip_rect.left, tip_rect.top,
		0, 0, SWP_NOACTIVATE | SWP_NOSIZE | SWP_SHOWWINDOW);
	return TRUE;
}

/******************************************************************************

	ShellOpen

	t@Cs

******************************************************************************/

static BOOL ShellOpen(TCHAR *FileName, TCHAR *CommnadLine)
{
	SHELLEXECUTEINFO sei;
	DWORD attributes;

	attributes = GetFileAttributes(FileName);
	if( attributes != -1){
		if( attributes & FILE_ATTRIBUTE_DIRECTORY){
			//Folder open
			CommnadLine = FileName;
			FileName = FILE_EXPLORER;
		}
	}
	if(lstrcmp(FileName, _T("\\")) == 0){
		CommnadLine = FileName;
		FileName = FILE_EXPLORER;
	}

	memset(&sei, 0, sizeof(SHELLEXECUTEINFO));
	sei.cbSize = sizeof(sei);
	sei.fMask = 0;
	sei.hwnd = NULL;
	sei.lpVerb = NULL;
	sei.lpFile = FileName;
	if(*CommnadLine != _T('\0')){
		sei.lpParameters = CommnadLine;
	}
	sei.lpDirectory = NULL;
	sei.nShow = SW_SHOWNORMAL;
	sei.hInstApp = hInst;
	return ShellExecuteEx(&sei);
}


/******************************************************************************

	WndProc

	CEBhEvV[W

******************************************************************************/

static LRESULT CALLBACK WndProc(HWND hWnd, UINT msg, WPARAM wParam, LPARAM lParam)
{
	static HBITMAP hBackBmp;
	HDC hdc;
	PAINTSTRUCT ps;
	SHRGINFO rg;
	int x, y;
	int i;

	switch (msg) {
	case WM_CREATE:
		if(hToolTip == NULL){
			hToolTip = CreateDialog(hInst, MAKEINTRESOURCE(IDD_DIALOG_TOOLTIP), FindWindow(_T("HHTaskBar"), NULL), ToolTipProc);
		}
		//t@Crbg}bvǂݍ
		if(hBackBmp != NULL){
			DeleteObject(hBackBmp);
			hBackBmp = NULL;
		}
		if(*backbmpfile != _T('\0')){
			hBackBmp = SHLoadDIBitmap(backbmpfile);
		}
		break;

	case WM_DESTROY:
		DestroyWindow(hToolTip);
		hToolTip = NULL;
		if(hBackBmp != NULL){
			DeleteObject(hBackBmp);
			hBackBmp = NULL;
		}
		if(IconList != NULL){
			ImageList_Destroy((void *)IconList);
			IconList = NULL;
		}
		if(FileList != NULL){
			LocalFree(FileList);
		}
		FileList = NULL;
		FileListCnt = 0;
		return 0;

	case WM_TODAYCUSTOM_CLEARCACHE:
		break;

	case WM_TODAYCUSTOM_QUERYREFRESHCACHE:
		if (Refresh){
			Refresh = FALSE;

			//EBhE̍̎擾
			for (x = WinLeftMargin, y = WinTopMargin, i = 0; i < FileListCnt; i++){
				if ((x + IconSize + (HMargin * 2)) > GetSystemMetrics(SM_CXSCREEN) - WinRightMargin){
					x = WinLeftMargin;
					y += IconSize + (VMargin * 2);
				}
				x += IconSize + (HMargin * 2);
			}
			y += IconSize + (VMargin * 2) + WinBottomMargin;
			((TODAYLISTITEM *)(wParam))->cyp = y;

			SetTimer (hWnd, ID_ICON_TIMER, ShowIconSec * 1000, NULL);
			return TRUE;
		}
		return FALSE;

	case WM_TODAYCUSTOM_RECEIVEDSELECTION:
		hasFocus = TRUE;
		if (wParam == VK_DOWN) {
			SelItem = CurItem = 0;
		}
		else if (wParam == VK_UP) {
			SelItem = CurItem = FileListCnt-1;
		}
		else {
			SelItem = CurItem = 0;
		}
		if (SelItem != -1) {
			ShowToolTip (hWnd, 0, 0);
		}
		return TRUE;

	case WM_TODAYCUSTOM_LOSTSELECTION:
		hasFocus = FALSE;
		SelItem = -1;
		ShowWindow (hToolTip, SW_HIDE);
		return TRUE;

	case WM_TODAYCUSTOM_USERNAVIGATION:
		// ㉺L[ő
		if (CtrlUpDown) {
			if (wParam == VK_UP) {
				if (CurItem > 0) {
					CurItem--;
				}
				else {
					return FALSE;
				}
			}
			else if (wParam == VK_DOWN) {
				if (CurItem < FileListCnt-1) {
					CurItem++;
				}
				else {
					return FALSE;
				}
			}
			else {
				return FALSE;
			}
		}
		// ㉺ẼL[ő
		else {
			if (wParam == VK_LEFT) {
				if (CurItem > 0) {
					CurItem--;
				}
				else {
					return FALSE;
				}
			}
			else if (wParam == VK_RIGHT) {
				if (CurItem < FileListCnt-1) {
					CurItem++;
				}
				else {
					return FALSE;
				}
			}
			else {
				return FALSE;
			}
		}

		if (CurItem != SelItem) {
			SelItem = CurItem;
			if (SelItem != -1) {
				ShowToolTip (hWnd, 0, 0);
			}
			InvalidateRect (hWnd, 0, FALSE);
			UpdateWindow (hWnd);
		}
		return TRUE;

	case WM_TODAYCUSTOM_ACTION:
		if (SelItem!=-1){
			ShellOpen ((FileList + SelItem)->FileName, (FileList + SelItem)->CommnadLine);
		}
		return TRUE;

	case WM_LBUTTONDOWN:
		SelItem = Point2Item (LOWORD(lParam), HIWORD(lParam));
		InvalidateRect (hWnd, NULL, FALSE);
		UpdateWindow (hWnd);

		rg.cbSize = sizeof(SHRGINFO);
		rg.hwndClient = hWnd;
		rg.ptDown.x = LOWORD(lParam);
		rg.ptDown.y = HIWORD(lParam);
#ifdef _WCE_PPC2002
		rg.dwFlags = SHRG_RETURNCMD | SHRG_NOANIMATION;
#else
		rg.dwFlags = SHRG_RETURNCMD;
#endif

		if(SelItem != -1 && SHRecognizeGesture(&rg) == GN_CONTEXTMENU){
			ShowToolTip (hWnd, rg.ptDown.x, rg.ptDown.y);
		}
		SetCapture (hWnd);
		SendMessage (GetParent (hWnd), TODAYM_TOOKSELECTION, 0, 0);
		break;

	case WM_LBUTTONUP:
		ShowWindow(hToolTip, SW_HIDE);
		ReleaseCapture();
		i = Point2Item(LOWORD(lParam), HIWORD(lParam));
		if(i != -1 && i == SelItem){
			ShellOpen((FileList + i)->FileName, (FileList + i)->CommnadLine);
			CurItem = SelItem;
		}
		SelItem = -1;
		InvalidateRect(hWnd, NULL, FALSE);
		UpdateWindow(hWnd);
		break;

	case WM_PAINT:
		hdc = BeginPaint(hWnd, &ps);
		OnPaint(hWnd, hdc, &ps, hBackBmp);
		EndPaint(hWnd, &ps);
		break;

	case WM_ERASEBKGND:
		return 1;

	case WM_TIMER:
		switch (wParam) {
		case ID_ICON_TIMER:
			if(SetImegeListIcon(FileList, FileListCnt, IconSize) == FALSE){
				break;
			}
			KillTimer(hWnd, ID_ICON_TIMER);
			InvalidateRect(hWnd, NULL, FALSE);
			UpdateWindow(hWnd);
			break;
		}
		break;

	default:
		return DefWindowProc(hWnd, msg, wParam, lParam);
	}
	return 0;
}


/******************************************************************************

	InitInstance

	EBhE̍쐬

******************************************************************************/

static HWND InitInstance(HWND pWnd, TODAYLISTITEM *ptli)
{
	WNDCLASS wc;

	hInst = ptli->hinstDLL;

	//ݒǂݍ
	GetOption();
	CreateFileList();

	//EBhENX̓o^
	wc.style = CS_HREDRAW | CS_VREDRAW;
	wc.hCursor = 0;
	wc.lpszMenuName = 0;
	wc.lpfnWndProc = (WNDPROC)WndProc;
	wc.cbClsExtra = 0;
	wc.cbWndExtra = 0;
	wc.hInstance = ptli->hinstDLL;
	wc.hIcon = NULL;
	wc.hbrBackground = (HBRUSH)GetStockObject(WHITE_BRUSH);
	wc.lpszClassName = MAIN_WND_CLASS;
	UnregisterClass(MAIN_WND_CLASS, ptli->hinstDLL);
	RegisterClass(&wc);

	Refresh = TRUE;

	//EBhE̍쐬
	return CreateWindow(MAIN_WND_CLASS, WINDOW_TITLE, WS_CHILD | WS_VISIBLE, CW_DEFAULT, CW_DEFAULT, 0, 0,
		pWnd, NULL, ptli->hinstDLL, NULL);
}


/******************************************************************************

	InitializeCustomItem

	

******************************************************************************/

HWND APIENTRY InitializeCustomItem(TODAYLISTITEM *ptli, HWND pWnd)
{
	if(ptli->fEnabled == 0){
		return NULL;
	}
	//EChE̍쐬
	return InitInstance(pWnd, ptli);
}


/******************************************************************************

	OptionDlgProc

	ݒ

******************************************************************************/

static BOOL CALLBACK OptionDlgProc(HWND hDlg, UINT uMsg, WPARAM wParam, LPARAM lParam)
{
	SHINITDLGINFO shidi;
	TCHAR buf[BUF_SIZE];
//	DWORD attr;

	switch (uMsg) {
	case WM_INITDIALOG:
		//PocketPCp
		shidi.dwMask = SHIDIM_FLAGS;
		shidi.dwFlags = SHIDIF_DONEBUTTON | SHIDIF_SIPDOWN | SHIDIF_SIZEDLGFULLSCREEN | SHIDIF_WANTSCROLLBAR;
		shidi.hDlg = hDlg;
		SHInitDialog (&shidi);

		SetWindowText (hDlg, _T("Options"));

//		attr =  SIP_INPUT_NUMERIC |
//				SIP_INPUT_ALPHANUMERIC |		
//				SIP_INPUT_HIRAGANA |			
//				SIP_INPUT_KATAKANA |			
//				SIP_INPUT_EVERYTHING |		
//				SIP_INPUT_PASSWORD |         
//				SIP_INPUT_HALFWIDTH |		
//				SIP_INPUT_FULLWIDTH;		
//		ImmSIPanelState (SIP_INPUT_ATTRIBUTES, (PVOID)attr);

		//Rg[̏
		SendDlgItemMessage(hDlg, IDC_EDIT_BACKBMP, WM_SETTEXT, 0, (LPARAM)backbmpfile);
		SendDlgItemMessage(hDlg, IDC_CHECK_STRETCH, BM_SETCHECK, stretch_backbmp, 0);
		SendDlgItemMessage(hDlg, IDC_CHECK_UPDOWN, BM_SETCHECK, CtrlUpDown, 0);
		SetDlgItemInt(hDlg, IDC_EDIT_ICONSIZE, IconSize, FALSE);
		SetDlgItemInt(hDlg, IDC_EDIT_HMARGIN, HMargin, FALSE);
		SetDlgItemInt(hDlg, IDC_EDIT_VMARGIN, VMargin, FALSE);
		SetDlgItemInt(hDlg, IDC_EDIT_WINLEFTMARGIN, WinLeftMargin, FALSE);
		SetDlgItemInt(hDlg, IDC_EDIT_WINTOPMARGIN, WinTopMargin, FALSE);
		SetDlgItemInt(hDlg, IDC_EDIT_WINRIGHTMARGIN, WinRightMargin, FALSE);
		SetDlgItemInt(hDlg, IDC_EDIT_WINBOTTOMMARGIN, WinBottomMargin, FALSE);
		break;

	case WM_COMMAND:
		switch(LOWORD(wParam))
		{
		case IDC_EDIT_BACKBMP:
		case IDC_EDIT_ICONSIZE:
		case IDC_EDIT_HMARGIN:
		case IDC_EDIT_VMARGIN:
		case IDC_EDIT_WINLEFTMARGIN:
		case IDC_EDIT_WINTOPMARGIN:
		case IDC_EDIT_WINRIGHTMARGIN:
		case IDC_EDIT_WINBOTTOMMARGIN:
			switch(HIWORD(wParam)){
			case EN_SETFOCUS:
				SHSipPreference(hDlg, SIP_UP);
				break;
			case EN_KILLFOCUS:
				SHSipPreference(hDlg, SIP_DOWN);
				break;
			}
			break;

		case IDC_BUTTON_BACKBMP:
			if(SelectFile(hDlg, hInst, NULL, buf) == TRUE){
				SendDlgItemMessage(hDlg, IDC_EDIT_BACKBMP, WM_SETTEXT, 0, (LPARAM)buf);
			}
			break;

		case IDOK:
			//ݒ̎擾
			SendDlgItemMessage(hDlg, IDC_EDIT_BACKBMP, WM_GETTEXT, BUF_SIZE - 1, (LPARAM)backbmpfile);
			stretch_backbmp = SendDlgItemMessage(hDlg, IDC_CHECK_STRETCH, BM_GETCHECK, 0, 0);
			CtrlUpDown = SendDlgItemMessage(hDlg, IDC_CHECK_UPDOWN, BM_GETCHECK, 0, 0);

			IconSize = GetDlgItemInt(hDlg, IDC_EDIT_ICONSIZE, NULL, FALSE);
			HMargin = GetDlgItemInt(hDlg, IDC_EDIT_HMARGIN, NULL, FALSE);
			VMargin = GetDlgItemInt(hDlg, IDC_EDIT_VMARGIN, NULL, FALSE);
			WinLeftMargin = GetDlgItemInt(hDlg, IDC_EDIT_WINLEFTMARGIN, NULL, FALSE);
			WinTopMargin = GetDlgItemInt(hDlg, IDC_EDIT_WINTOPMARGIN, NULL, FALSE);
			WinRightMargin = GetDlgItemInt(hDlg, IDC_EDIT_WINRIGHTMARGIN, NULL, FALSE);
			WinBottomMargin = GetDlgItemInt(hDlg, IDC_EDIT_WINBOTTOMMARGIN, NULL, FALSE);
			EndDialog(hDlg, TRUE);
			break;
		}
		break;

	default:
		return FALSE;
	}
	return TRUE;
}


/******************************************************************************

	EditDlgProc

	ݒ

******************************************************************************/

static BOOL CALLBACK EditDlgProc(HWND hDlg, UINT uMsg, WPARAM wParam, LPARAM lParam)
{
	SHINITDLGINFO shidi;
	HWND hListView;
	LV_ITEM lvi;
	TCHAR name[BUF_SIZE];
	TCHAR path[BUF_SIZE];
	TCHAR cmd[BUF_SIZE];
	TCHAR *p, *r;
	static int index;

	switch(uMsg)
	{
	case WM_INITDIALOG:
		//PocketPCp
		shidi.dwMask = SHIDIM_FLAGS;
		shidi.dwFlags = SHIDIF_DONEBUTTON | SHIDIF_SIPDOWN | SHIDIF_SIZEDLGFULLSCREEN | SHIDIF_WANTSCROLLBAR;
		shidi.hDlg = hDlg;
		SHInitDialog(&shidi);

		SetWindowText(hDlg, _T("File"));

		index = lParam;
		if(lParam >= 0){
			hListView = GetDlgItem(GetParent(hDlg), IDC_LIST_FILE);

			*name = _T('\0');
			ListView_GetItemText(hListView, index, 0, name, BUF_SIZE - 1);
			SendDlgItemMessage(hDlg, IDC_EDIT_NAME, WM_SETTEXT, 0, (LPARAM)name);

			*name = _T('\0');
			ListView_GetItemText(hListView, index, 1, name, BUF_SIZE - 1);
			SendDlgItemMessage(hDlg, IDC_EDIT_PATH, WM_SETTEXT, 0, (LPARAM)name);

			*name = _T('\0');
			ListView_GetItemText(hListView, index, 2, name, BUF_SIZE - 1);
			SendDlgItemMessage(hDlg, IDC_EDIT_CMD, WM_SETTEXT, 0, (LPARAM)name);
		}
		break;

	case WM_COMMAND:
		switch(LOWORD(wParam))
		{
		case IDC_EDIT_NAME:
		case IDC_EDIT_PATH:
		case IDC_EDIT_CMD:
			switch(HIWORD(wParam)){
			case EN_SETFOCUS:
				SHSipPreference(hDlg, SIP_UP);
				break;
			case EN_KILLFOCUS:
				SHSipPreference(hDlg, SIP_DOWN);
				break;
			}
			break;

		case IDC_BUTTON_FILESELECT:
			if(SelectFile(hDlg, hInst, NULL, path) == TRUE){
				SendDlgItemMessage(hDlg, IDC_EDIT_PATH, WM_SETTEXT, 0, (LPARAM)path);

				if(SendDlgItemMessage(hDlg, IDC_EDIT_NAME, WM_GETTEXTLENGTH, 0, 0) > 0){
					break;
				}
				for(p = r = path; *p != _T('\0'); p++){
					if(*p == _T('\\')){
						r = p;
					}
				}
				lstrcpy(name, r + 1);
				for(p = name; *p != _T('\0') && *p != _T('.'); p++);
				*p = _T('\0');
				SendDlgItemMessage(hDlg, IDC_EDIT_NAME, WM_SETTEXT, 0, (LPARAM)name);
			}
			break;

		case IDC_BUTTON_CMDSELECT:
			if(SelectFile(hDlg, hInst, NULL, cmd) == TRUE){
				SendDlgItemMessage(hDlg, IDC_EDIT_CMD, WM_SETTEXT, 0, (LPARAM)cmd);
			}
			break;

		case IDCANCEL:
			EndDialog(hDlg, FALSE);
			break;

		case IDOK:
			//ݒ̎擾
			*name = _T('\0');
			SendDlgItemMessage(hDlg, IDC_EDIT_NAME, WM_GETTEXT, BUF_SIZE - 1, (LPARAM)name);
			*path = _T('\0');
			SendDlgItemMessage(hDlg, IDC_EDIT_PATH, WM_GETTEXT, BUF_SIZE - 1, (LPARAM)path);
			if(*name == _T('\0') || *path == _T('\0')){
				break;
			}
			if(lstrcmp(path, _T("\\")) != 0 && *(path + lstrlen(path) - 1) == _T('\\')){
				*(path + lstrlen(path) - 1) = _T('\0');
			}
			*cmd = _T('\0');
			SendDlgItemMessage(hDlg, IDC_EDIT_CMD, WM_GETTEXT, BUF_SIZE - 1, (LPARAM)cmd);

			hListView = GetDlgItem(GetParent(hDlg), IDC_LIST_FILE);
			if(index == -1){
				// Xgr[ɃACeǉ
				memset(&lvi, 0, sizeof(LVITEM));
				lvi.mask = LVIF_TEXT | LVIF_IMAGE;
				lvi.iItem = ListView_GetItemCount(hListView);
				lvi.iSubItem = 0;
				lvi.pszText = name;
				lvi.cchTextMax = lstrlen(name);
				lvi.iImage = 0;
				index = ListView_InsertItem(hListView, &lvi);
			}else{
				ListView_SetItemText(hListView, index, 0, name);
			}
			ListView_SetItemText(hListView, index, 1, path);
			ListView_SetItemText(hListView, index, 2, cmd);
			EndDialog(hDlg, TRUE);
			break;
		}
		break;

	default:
		return FALSE;
	}
	return TRUE;
}


/******************************************************************************

	SetLvIcon

	Xgr[ɃACRݒ

******************************************************************************/

static void SetLvIcon(HWND hListView)
{
	HIMAGELIST SysIconList;
	HIMAGELIST IconList;
	SHFILEINFO  shfi;
	LV_ITEM lvi;
	TCHAR buf[BUF_SIZE];
	int i, cnt;

	IconList = ListView_GetImageList(hListView, LVSIL_SMALL);
	if(IconList == NULL){
		IconList = ImageList_Create(GetSystemMetrics(SM_CXSMICON), GetSystemMetrics(SM_CYSMICON), ILC_COLOR | ILC_MASK, 0, 0);
	}else{
		ImageList_Remove(IconList, -1);
	}
	ImageList_SetBkColor(IconList, GetSysColor(COLOR_WINDOW));

	//VXeC[WXg̎擾
	SysIconList = (HIMAGELIST)SHGetFileInfo(_T(""), 0, &shfi, sizeof(SHFILEINFO),
		SHGFI_ICON | SHGFI_SMALLICON | SHGFI_SYSICONINDEX);
	if(SysIconList == NULL){
		return;
	}

	cnt = ListView_GetItemCount(hListView);
	for(i = 0; i < cnt; i++){
		*buf = '\0';
		ListView_GetItemText(hListView, i, 1, buf, BUF_SIZE - 1);
		ImageListIconAdd(IconList, SysIconList, GetSystemMetrics(SM_CXSMICON), NULL, buf);

		memset(&lvi, 0, sizeof(LVITEM));
		lvi.mask = LVIF_IMAGE;
		lvi.iItem = i;
		lvi.iSubItem = 0;
		lvi.iImage = i;
		ListView_SetItem(hListView, &lvi);
	}
	ListView_SetImageList(hListView, IconList, LVSIL_SMALL);
}


/******************************************************************************

	ListView_MoveItem

	Xgr[̃ACeړ

******************************************************************************/

static void ListView_MoveItem(HWND hListView, int SelectItem, int Move, int ColCnt)
{
	LV_ITEM lvi;
	TCHAR buf[3][BUF_SIZE];
	int i = 0;
	int image;

	for(i = 0;i < ColCnt;i++){
		*(*(buf + i)) = '\0';
	}

	for(i = 0;i < ColCnt;i++){
		ListView_GetItemText(hListView, SelectItem, i, *(buf + i), BUF_SIZE - 1);
	}

	memset(&lvi, 0, sizeof(LVITEM));
	lvi.mask = LVIF_IMAGE;
	lvi.iItem = SelectItem;
	lvi.iSubItem = 0;
	lvi.iImage = 0;
	ListView_GetItem(hListView, &lvi);
	image = lvi.iImage;

	ListView_DeleteItem(hListView, SelectItem);

	SelectItem = SelectItem + Move;

	memset(&lvi, 0, sizeof(LVITEM));
	lvi.mask = LVIF_TEXT | LVIF_IMAGE;
	lvi.iItem = SelectItem;
	lvi.iSubItem = 0;
	lvi.pszText = *buf;
	lvi.cchTextMax = lstrlen(*buf);
	lvi.iImage = image;
	ListView_InsertItem(hListView, &lvi);

	for(i = 1;i < ColCnt;i++){
		ListView_SetItemText(hListView, SelectItem, i, *(buf + i));
	}
	ListView_SetItemState(hListView, SelectItem,
		LVIS_FOCUSED | LVIS_SELECTED, LVIS_FOCUSED | LVIS_SELECTED);
	ListView_EnsureVisible(hListView, SelectItem, TRUE);
}


/******************************************************************************

	CustomItemOptionsDlgProc

	ݒ

******************************************************************************/

BOOL APIENTRY CustomItemOptionsDlgProc(HWND hDlg, UINT uMsg, UINT wParam, LONG lParam)
{
	SHINITDLGINFO shidi;
	LVCOLUMN lvc;
	LV_ITEM lvi;
	int ItemIndex;
	int i;

	switch (uMsg) {
	case WM_INITDIALOG:
		//PocketPCp
		shidi.dwMask = SHIDIM_FLAGS;
		shidi.dwFlags = SHIDIF_DONEBUTTON | SHIDIF_SIPDOWN | SHIDIF_SIZEDLGFULLSCREEN | SHIDIF_WANTSCROLLBAR;
		shidi.hDlg = hDlg;
		SHInitDialog (&shidi);

		SetWindowText(hDlg, _T("tdLaunch"));

		//ݒǂݍ
		GetOption();
		CreateFileList();

		lvc.mask = LVCF_FMT | LVCF_SUBITEM | LVCF_TEXT | LVCF_WIDTH;
		lvc.fmt = LVCFMT_LEFT;

		lvc.cx = 150;
		lvc.pszText = _T("Name");
		lvc.cchTextMax = lstrlen(_T("Name"));
		lvc.iSubItem = 0;
		ListView_InsertColumn(GetDlgItem(hDlg, IDC_LIST_FILE), 0, &lvc);

		lvc.cx = 150;
		lvc.pszText = _T("File path");
		lvc.cchTextMax = lstrlen(_T("Path"));
		lvc.iSubItem = 1;
		ListView_InsertColumn(GetDlgItem(hDlg, IDC_LIST_FILE), 1, &lvc);

		lvc.cx = 100;
		lvc.pszText = _T("Command line");
		lvc.cchTextMax = lstrlen(_T("Command line"));
		lvc.iSubItem = 2;
		ListView_InsertColumn(GetDlgItem(hDlg, IDC_LIST_FILE), 2, &lvc);

		for(i = 0; i < FileListCnt; i++){
			// Xgr[ɃACeǉ
			memset(&lvi, 0, sizeof(LVITEM));
			lvi.mask = LVIF_TEXT | LVIF_IMAGE;
			lvi.iItem = ListView_GetItemCount(GetDlgItem(hDlg, IDC_LIST_FILE));
			lvi.iSubItem = 0;
			lvi.pszText = (FileList + i)->Name;
			lvi.cchTextMax = lstrlen((FileList + i)->Name);
			lvi.iImage = 0;
			ItemIndex = ListView_InsertItem(GetDlgItem(hDlg, IDC_LIST_FILE), &lvi);

			ListView_SetItemText(GetDlgItem(hDlg, IDC_LIST_FILE), ItemIndex, 1, (FileList + i)->FileName);
			ListView_SetItemText(GetDlgItem(hDlg, IDC_LIST_FILE), ItemIndex, 2, (FileList + i)->CommnadLine);
		}
		SetLvIcon(GetDlgItem(hDlg, IDC_LIST_FILE));
		break;

	case WM_COMMAND:
		switch (LOWORD(wParam)) {
		case IDC_BUTTON_ADD:
			DialogBoxParam(hInst, MAKEINTRESOURCE(IDD_DIALOG_EDIT), hDlg, EditDlgProc, -1);
			SetLvIcon(GetDlgItem(hDlg, IDC_LIST_FILE));
			SHSipPreference(hDlg, SIP_DOWN);
			break;

		case IDC_BUTTON_EDIT:
			if((i = ListView_GetNextItem(GetDlgItem(hDlg, IDC_LIST_FILE),
				-1, LVNI_FOCUSED | LVIS_SELECTED)) == -1){
				break;
			}
			DialogBoxParam(hInst, MAKEINTRESOURCE(IDD_DIALOG_EDIT), hDlg, EditDlgProc, i);
			SetLvIcon(GetDlgItem(hDlg, IDC_LIST_FILE));
			SHSipPreference(hDlg, SIP_DOWN);
			break;

		case IDC_BUTTON_DELETE:
			if(ListView_GetSelectedCount(GetDlgItem(hDlg, IDC_LIST_FILE)) <= 0){
				break;
			}
			if(MessageBox(hDlg, _T("Delete select item?"), _T("Delete"), MB_ICONQUESTION | MB_YESNO) == IDNO){
				break;
			}
			while((i = ListView_GetNextItem(GetDlgItem(hDlg, IDC_LIST_FILE), -1, LVNI_SELECTED)) != -1){
				ListView_DeleteItem(GetDlgItem(hDlg, IDC_LIST_FILE), i);
			}
			break;

		case IDC_BUTTON_UP:
			if((i = ListView_GetNextItem(GetDlgItem(hDlg, IDC_LIST_FILE), -1, LVNI_SELECTED)) <= 0){
				break;
			}
			ListView_MoveItem(GetDlgItem(hDlg, IDC_LIST_FILE), i, -1, 3);
			break;

		case IDC_BUTTON_DOWN:
			if((i = ListView_GetNextItem(GetDlgItem(hDlg, IDC_LIST_FILE), -1, LVNI_SELECTED)) == -1){
				break;
			}
			if(i == ListView_GetItemCount(GetDlgItem(hDlg, IDC_LIST_FILE)) - 1){
				break;
			}
			ListView_MoveItem(GetDlgItem(hDlg, IDC_LIST_FILE), i, 1, 3);
			break;

		case IDC_BUTTON_OPTION:
			DialogBoxParam(hInst, MAKEINTRESOURCE(IDD_DIALOG_OPTION), hDlg, OptionDlgProc, 0);
			SHSipPreference(hDlg, SIP_DOWN);
			break;

		case IDC_BUTTON_UNINSTALL:
			if(MessageBox(hDlg, _T("Delete tdLaunch information?"), _T("Uninstall"), MB_ICONSTOP | MB_YESNO) == IDYES){
				//tdLaunchWXg̍폜
				RegDeleteFileList();
				RegDeleteKey(HKEY_CURRENT_USER, REG_PATH);
			}
			if(MessageBox(hDlg, _T("Delete today information?"), _T("Uninstall"), MB_ICONSTOP | MB_YESNO) == IDYES){
				//todayWXg̍폜
				RegDeleteKey(HKEY_LOCAL_MACHINE, _T("Software\\Microsoft\\Today\\Items\\tdLaunch"));
				MessageBox(hDlg, _T("Information was deleted. Please uninstall."), _T("Info"), MB_OK | MB_ICONINFORMATION);
			}
			EndDialog(hDlg, IDOK);
			break;

		case IDOK:
			if(FileList != NULL){
				LocalFree(FileList);
				FileListCnt = 0;
			}
			i = ListView_GetItemCount(GetDlgItem(hDlg, IDC_LIST_FILE));
			FileList = (FILELIST *)LocalAlloc(LPTR, sizeof(FILELIST) * i);
			if(FileList == NULL){
				break;
			}
			FileListCnt = i;

			for(i = 0;i < FileListCnt;i++){
				ListView_GetItemText(GetDlgItem(hDlg, IDC_LIST_FILE), i, 0, (FileList + i)->Name, BUF_SIZE - 1);
				ListView_GetItemText(GetDlgItem(hDlg, IDC_LIST_FILE), i, 1, (FileList + i)->FileName, BUF_SIZE - 1);
				ListView_GetItemText(GetDlgItem(hDlg, IDC_LIST_FILE), i, 2, (FileList + i)->CommnadLine, BUF_SIZE - 1);
				(FileList + i)->Index = i;
			}

			SaveFileList();
			SetOption();

			ListView_DeleteAllItems(GetDlgItem(hDlg, IDC_LIST_FILE));
			ImageList_Destroy((void *)ListView_GetImageList(GetDlgItem(hDlg, IDC_LIST_FILE), LVSIL_SMALL));
			EndDialog(hDlg, IDOK);
			break;
		}
		break;

	default:
		return FALSE;
	}
	return TRUE;
}
/* End of source */
